Search Results for

Show / Hide Table of Contents

# Class View

View is the base class for all views on the screen and represents a visible element that can render itself and contains zero or more nested views.

##### Inheritance

System.Object
Responder
View
Button
CheckBox
ColorPicker
ComboBox
FrameView
GraphView
HexView
Label
LineView
ListView
MenuBar
PanelView
ProgressBar
RadioGroup
ScrollBarView
ScrollView
StatusBar
TableView
TabView
TextField
TextValidateField
TextView
Toplevel
TreeView<T>

##### Implements

System.IDisposable
System.ComponentModel.ISupportInitializeNotification
System.ComponentModel.ISupportInitialize

##### Remarks

The View defines the base functionality for user interface elements in Terminal.Gui. Views can contain one or more subviews, can respond to user input and render themselves on the screen.

Views supports two layout styles: Absolute or Computed. The choice as to which layout style is used by the View is determined when the View is initialized. To create a View using Absolute layout, call a constructor that takes a Rect parameter to specify the absolute position and size (the `View.Frame`)/. To create a View using Computed layout use a constructor that does not take a Rect parameter and set the X, Y, Width and Height properties on the view. Both approaches use coordinates that are relative to the container they are being added to.

To switch between Absolute and Computed layout, use the LayoutStyle property.

Computed layout is more flexible and supports dynamic console apps where controls adjust layout as the terminal resizes or other Views change size or position. The X, Y, Width and Height properties are Dim and Pos objects that dynamically update the position of a view. The X and Y properties are of type Pos and you can use either absolute positions, percentages or anchor points. The Width and Height properties are of type Dim and can use absolute position, percentages and anchors. These are useful as they will take care of repositioning views when view's frames are resized or if the terminal size changes.

Absolute layout requires specifying coordinates and sizes of Views explicitly, and the View will typically stay in a fixed position and size. To change the position and size use the Frame property.

Subviews (child views) can be added to a View by calling the Add(View) method. The container of a View can be accessed with the SuperView property.

To flag a region of the View's Bounds to be redrawn call SetNeedsDisplay(Rect). To flag the entire view for redraw call SetNeedsDisplay().

Views have a ColorScheme property that defines the default colors that subviews should use for rendering. This ensures that the views fit in the context where they are being used, and allows for themes to be plugged in. For example, the default colors for windows and toplevels uses a blue background, while it uses a white background for dialog boxes and a red background for errors.

Subclasses should not rely on ColorScheme being set at construction time. If a ColorScheme is not set on a view, the view will inherit the value from its SuperView and the value might only be valid once a view has been added to a SuperView.

By using ColorScheme applications will work both in color as well as black and white displays.

Views that are focusable should implement the PositionCursor() to make sure that the cursor is placed in a location that makes sense. Unix terminals do not have a way of hiding the cursor, so it can be distracting to have the cursor left at the last focused view. So views should make sure that they place the cursor in a visually sensible place.

The LayoutSubviews() method is invoked when the size or layout of a view has changed. The default processing system will keep the size and dimensions for views that use the Absolute, and will recompute the frames for the vies that use Computed.

##### Inherited Members

Responder.MouseEvent(MouseEvent)
Responder.Dispose()

###### Namespace: Terminal.Gui

###### Assembly: Terminal.Gui.dll

##### Syntax

    public class View : Responder

### Constructors

#### View()

Initializes a new instance of View using Computed layout.

##### Declaration

    public View()

#### View(ustring, TextDirection, Border)

Initializes a new instance of View using Computed layout.

##### Declaration

    public View(ustring text, TextDirection direction, Border border = null)

##### Parameters

Type | Name | Description
--- | --- | ---
NStack.ustring | text | text to initialize the Text property with.
TextDirection | direction | The text direction.
Border | border | The Border.

#### View(Int32, Int32, ustring)

Initializes a new instance of View using Absolute layout.

##### Declaration

    public View(int x, int y, ustring text)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | x | column to locate the Label.
System.Int32 | y | row to locate the Label.
NStack.ustring | text | text to initialize the Text property with.

#### View(Rect)

Initializes a new instance of a Absolute View class with the absolute dimensions specified in the `frame` parameter.

##### Declaration

    public View(Rect frame)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | frame | The region covered by this view.

#### View(Rect, ustring, Border)

Initializes a new instance of View using Absolute layout.

##### Declaration

    public View(Rect rect, ustring text, Border border = null)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | rect | Location.
NStack.ustring | text | text to initialize the Text property with.
Border | border | The Border.

### Properties

#### AutoSize

Gets or sets a flag that determines whether the View will be automatically resized to fit the Text. The default is `false`. Set to `true` to turn on AutoSize. If AutoSize is `true` the Width and Height will always be used if the text size is lower. If the text size is higher the bounds will be resized to fit it. In addition, if ForceValidatePosDim is `true` the new values of Width and Height must be of the same types of the existing one to avoid breaking the Dim settings.

##### Declaration

    public virtual bool AutoSize { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

#### Border

##### Declaration

    public virtual Border Border { get; set; }

##### Property Value

Type | Description
--- | ---
Border |

#### Bounds

The bounds represent the View-relative rectangle used for this view; the area inside of the view.

##### Declaration

    public Rect Bounds { get; set; }

##### Property Value

Type | Description
--- | ---
Rect | The bounds.

#### CanFocus

Gets or sets a value indicating whether this Responder can focus.

##### Declaration

    public override bool CanFocus { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean | `true` if can focus; otherwise, `false`.

##### Overrides

Responder.CanFocus

#### ColorScheme

The color scheme for this view, if it is not defined, it returns the SuperView's color scheme.

##### Declaration

    public virtual ColorScheme ColorScheme { get; set; }

##### Property Value

Type | Description
--- | ---
ColorScheme |

#### Data

Gets or sets arbitrary data for the view.

##### Declaration

    public object Data { get; set; }

##### Property Value

Type | Description
--- | ---
System.Object |

#### Driver

Points to the current driver in use by the view, it is a convenience property for simplifying the development of new views.

##### Declaration

    public static ConsoleDriver Driver { get; }

##### Property Value

Type | Description
--- | ---
ConsoleDriver |

#### Enabled

Gets or sets a value indicating whether this Responder can respond to user interaction.

##### Declaration

    public override bool Enabled { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

##### Overrides

Responder.Enabled

#### Focused

Returns the currently focused view inside this view, or null if nothing is focused.

##### Declaration

    public View Focused { get; }

##### Property Value

Type | Description
--- | ---
View | The focused.

#### ForceValidatePosDim

Forces validation with Computed layout to avoid breaking the Pos and Dim settings.

##### Declaration

    public bool ForceValidatePosDim { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

#### Frame

Gets or sets the frame for the view. The frame is relative to the view's container (SuperView).

##### Declaration

    public virtual Rect Frame { get; set; }

##### Property Value

Type | Description
--- | ---
Rect | The frame.

#### HasFocus

Gets or sets a value indicating whether this Responder has focus.

##### Declaration

    public override bool HasFocus { get; }

##### Property Value

Type | Description
--- | ---
System.Boolean | `true` if has focus; otherwise, `false`.

##### Overrides

Responder.HasFocus

#### Height

Gets or sets the height of the view. Only used the LayoutStyle is Computed.

##### Declaration

    public Dim Height { get; set; }

##### Property Value

Type | Description
--- | ---
Dim | The height.

#### HotKey

Gets or sets the HotKey defined for this view. A user pressing HotKey on the keyboard while this view has focus will cause the Clicked event to fire.

##### Declaration

    public virtual Key HotKey { get; set; }

##### Property Value

Type | Description
--- | ---
Key |

#### HotKeySpecifier

Gets or sets the specifier character for the hotkey (e.g. '_'). Set to '\xffff' to disable hotkey support for this View instance. The default is '\xffff'.

##### Declaration

    public virtual Rune HotKeySpecifier { get; set; }

##### Property Value

Type | Description
--- | ---
System.Rune |

#### Id

Gets or sets an identifier for the view;

##### Declaration

    public ustring Id { get; set; }

##### Property Value

Type | Description
--- | ---
NStack.ustring | The identifier.

#### IsAdded

Gets information if the view was already added to the SuperView.

##### Declaration

    public bool IsAdded { get; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

#### IsCurrentTop

Returns a value indicating if this View is currently on Top (Active)

##### Declaration

    public bool IsCurrentTop { get; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

#### IsInitialized

Get or sets if the View was already initialized. This derived from System.ComponentModel.ISupportInitializeNotification to allow notify all the views that are being initialized.

##### Declaration

    public virtual bool IsInitialized { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

#### LayoutStyle

Controls how the View's Frame is computed during the LayoutSubviews method, if the style is set to Absolute, LayoutSubviews does not change the Frame. If the style is Computed the Frame is updated using the X, Y, Width, and Height properties.

##### Declaration

    public LayoutStyle LayoutStyle { get; set; }

##### Property Value

Type | Description
--- | ---
LayoutStyle | The layout style.

#### MostFocused

Returns the most focused view in the chain of subviews (the leaf view that has the focus).

##### Declaration

    public View MostFocused { get; }

##### Property Value

Type | Description
--- | ---
View | The most focused.

#### PreserveTrailingSpaces

Gets or sets a flag that determines whether Text will have trailing spaces preserved or not when WordWrap(ustring, Int32, Boolean, Int32, TextDirection) is enabled. If `true` any trailing spaces will be trimmed when either the Text property is changed or when WordWrap(ustring, Int32, Boolean, Int32, TextDirection) is set to `true`. The default is `false`.

##### Declaration

    public virtual bool PreserveTrailingSpaces { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

#### Shortcut

This is the global setting that can be used as a global shortcut to invoke an action if provided.

##### Declaration

    public Key Shortcut { get; set; }

##### Property Value

Type | Description
--- | ---
Key |

#### ShortcutAction

The action to run if the Shortcut is defined.

##### Declaration

    public virtual Action ShortcutAction { get; set; }

##### Property Value

Type | Description
--- | ---
System.Action |

#### ShortcutTag

The keystroke combination used in the Shortcut as string.

##### Declaration

    public ustring ShortcutTag { get; }

##### Property Value

Type | Description
--- | ---
NStack.ustring |

#### Subviews

This returns a list of the subviews contained by this view.

##### Declaration

    public IList<View> Subviews { get; }

##### Property Value

Type | Description
--- | ---
System.Collections.Generic.IList<View> | The subviews.

#### SuperView

Returns the container for this view, or null if this view has not been added to a container.

##### Declaration

    public View SuperView { get; }

##### Property Value

Type | Description
--- | ---
View | The super view.

#### TabIndex

Indicates the index of the current View from the TabIndexes list.

##### Declaration

    public int TabIndex { get; set; }

##### Property Value

Type | Description
--- | ---
System.Int32 |

#### TabIndexes

This returns a tab index list of the subviews contained by this view.

##### Declaration

    public IList<View> TabIndexes { get; }

##### Property Value

Type | Description
--- | ---
System.Collections.Generic.IList<View> | The tabIndexes.

#### TabStop

This only be `true` if the CanFocus is also `true` and the focus can be avoided by setting this to `false`

##### Declaration

    public bool TabStop { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

#### Text

The text displayed by the View.

##### Declaration

    public virtual ustring Text { get; set; }

##### Property Value

Type | Description
--- | ---
NStack.ustring |

#### TextAlignment

Gets or sets how the View's Text is aligned horizontally when drawn. Changing this property will redisplay the View.

##### Declaration

    public virtual TextAlignment TextAlignment { get; set; }

##### Property Value

Type | Description
--- | ---
TextAlignment | The text alignment.

#### TextDirection

Gets or sets the direction of the View's Text. Changing this property will redisplay the View.

##### Declaration

    public virtual TextDirection TextDirection { get; set; }

##### Property Value

Type | Description
--- | ---
TextDirection | The text alignment.

#### TextFormatter

Gets or sets the TextFormatter which can be handled differently by any derived class.

##### Declaration

    public TextFormatter TextFormatter { get; set; }

##### Property Value

Type | Description
--- | ---
TextFormatter |

#### VerticalTextAlignment

Gets or sets how the View's Text is aligned verticaly when drawn. Changing this property will redisplay the View.

##### Declaration

    public virtual VerticalTextAlignment VerticalTextAlignment { get; set; }

##### Property Value

Type | Description
--- | ---
VerticalTextAlignment | The text alignment.

#### Visible

Gets or sets a value indicating whether this Responder and all its child controls are displayed.

##### Declaration

    public override bool Visible { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

##### Overrides

Responder.Visible

#### WantContinuousButtonPressed

Gets or sets a value indicating whether this View want continuous button pressed event.

##### Declaration

    public virtual bool WantContinuousButtonPressed { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

#### WantMousePositionReports

Gets or sets a value indicating whether this View wants mouse position reports.

##### Declaration

    public virtual bool WantMousePositionReports { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean | `true` if want mouse position reports; otherwise, `false`.

#### Width

Gets or sets the width of the view. Only used the LayoutStyle is Computed.

##### Declaration

    public Dim Width { get; set; }

##### Property Value

Type | Description
--- | ---
Dim | The width.

#### X

Gets or sets the X position for the view (the column). Only used the LayoutStyle is Computed.

##### Declaration

    public Pos X { get; set; }

##### Property Value

Type | Description
--- | ---
Pos | The X Position.

#### Y

Gets or sets the Y position for the view (the row). Only used the LayoutStyle is Computed.

##### Declaration

    public Pos Y { get; set; }

##### Property Value

Type | Description
--- | ---
Pos | The y position (line).

### Methods

#### Add(View)

Adds a subview (child) to this view.

##### Declaration

    public virtual void Add(View view)

##### Parameters

Type | Name | Description
--- | --- | ---
View | view |

#### Add(View[])

Adds the specified views (children) to the view.

##### Declaration

    public void Add(params View[] views)

##### Parameters

Type | Name | Description
--- | --- | ---
View[] | views | Array of one or more views (can be optional parameter).

#### AddCommand(Command, Func<Nullable<Boolean>>)

States that the given View supports a given `command` and what `f` to perform to make that command happen

If the `command` already has an implementation the `f` will replace the old one

##### Declaration

    protected void AddCommand(Command command, Func<Nullable<bool>> f)

##### Parameters

Type | Name | Description
--- | --- | ---
Command | command | The command.
System.Func<System.Nullable<System.Boolean>> | f | The function.

#### AddKeyBinding(Key, Command)

Adds a new key combination that will trigger the given `command` (if supported by the View - see GetSupportedCommands())

If the key is already bound to a different Command it will be rebound to this one

##### Declaration

    public void AddKeyBinding(Key key, Command command)

##### Parameters

Type | Name | Description
--- | --- | ---
Key | key |
Command | command |

#### AddRune(Int32, Int32, Rune)

Displays the specified character in the specified column and row of the View.

##### Declaration

    public void AddRune(int col, int row, Rune ch)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | col | Column (view-relative).
System.Int32 | row | Row (view-relative).
System.Rune | ch | Ch.

#### BeginInit()

This derived from System.ComponentModel.ISupportInitializeNotification to allow notify all the views that are beginning initialized.

##### Declaration

    public void BeginInit()

#### BringSubviewForward(View)

Moves the subview backwards in the hierarchy, only one step

##### Declaration

    public void BringSubviewForward(View subview)

##### Parameters

Type | Name | Description
--- | --- | ---
View | subview | The subview to send backwards

#### BringSubviewToFront(View)

Brings the specified subview to the front so it is drawn on top of any other views.

##### Declaration

    public void BringSubviewToFront(View subview)

##### Parameters

Type | Name | Description
--- | --- | ---
View | subview | The subview to send to the front

#### Clear()

Clears the view region with the current color.

##### Declaration

    public void Clear()

#### Clear(Rect)

Clears the specified region with the current color.

##### Declaration

    public void Clear(Rect regionScreen)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | regionScreen | The screen-relative region to clear.

#### ClearKeybinding(Command)

Removes all key bindings that trigger the given command. Views can have multiple different keys bound to the same command and this method will clear all of them.

##### Declaration

    public void ClearKeybinding(Command command)

##### Parameters

Type | Name | Description
--- | --- | ---
Command | command |

#### ClearKeybinding(Key)

Clears the existing keybinding (if any) for the given `key`

##### Declaration

    public void ClearKeybinding(Key key)

##### Parameters

Type | Name | Description
--- | --- | ---
Key | key |

#### ClearKeybindings()

Removes all bound keys from the View making including the default key combinations such as cursor navigation, scrolling etc

##### Declaration

    public void ClearKeybindings()

#### ClearLayoutNeeded()

Removes the Terminal.Gui.View.SetNeedsLayout setting on this view.

##### Declaration

    protected void ClearLayoutNeeded()

#### ClearNeedsDisplay()

Removes the SetNeedsDisplay() and the Terminal.Gui.View.ChildNeedsDisplay setting on this view.

##### Declaration

    protected void ClearNeedsDisplay()

#### ClipToBounds()

Sets the ConsoleDriver's clip region to the current View's Bounds.

##### Declaration

    public Rect ClipToBounds()

##### Returns

Type | Description
--- | ---
Rect | The existing driver's clip region, which can be then re-applied by setting `Driver.Clip` (Clip).

#### ContainsKeyBinding(Key)

Checks if key combination already exist.

##### Declaration

    public bool ContainsKeyBinding(Key key)

##### Parameters

Type | Name | Description
--- | --- | ---
Key | key | The key to check.

##### Returns

Type | Description
--- | ---
System.Boolean | `true` If the key already exist, `false`otherwise.

#### Dispose(Boolean)

Performs application-defined tasks associated with freeing, releasing, or resetting unmanaged resources.

##### Declaration

    protected override void Dispose(bool disposing)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Boolean | disposing |

##### Overrides

Responder.Dispose(Boolean)

#### DrawFrame(Rect, Int32, Boolean)

Draws a frame in the current view, clipped by the boundary of this view

##### Declaration

    public void DrawFrame(Rect region, int padding = 0, bool fill = false)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | region | View-relative region for the frame to be drawn.
System.Int32 | padding | The padding to add around the outside of the drawn frame.
System.Boolean | fill | If set to `true` it fill will the contents.

#### DrawHotString(ustring, Boolean, ColorScheme)

Utility function to draw strings that contains a hotkey using a ColorScheme and the "focused" state.

##### Declaration

    public void DrawHotString(ustring text, bool focused, ColorScheme scheme)

##### Parameters

Type | Name | Description
--- | --- | ---
NStack.ustring | text | String to display, the underscore before a letter flags the next letter as the hotkey.
System.Boolean | focused | If set to `true` this uses the focused colors from the color scheme, otherwise the regular ones.
ColorScheme | scheme | The color scheme to use.

#### DrawHotString(ustring, Attribute, Attribute)

Utility function to draw strings that contain a hotkey.

##### Declaration

    public void DrawHotString(ustring text, Attribute hotColor, Attribute normalColor)

##### Parameters

Type | Name | Description
--- | --- | ---
NStack.ustring | text | String to display, the hotkey specifier before a letter flags the next letter as the hotkey.
Attribute | hotColor | Hot color.
Attribute | normalColor | Normal color.

#### EndInit()

This derived from System.ComponentModel.ISupportInitializeNotification to allow notify all the views that are ending initialized.

##### Declaration

    public void EndInit()

#### EnsureFocus()

Finds the first view in the hierarchy that wants to get the focus if nothing is currently focused, otherwise, it does nothing.

##### Declaration

    public void EnsureFocus()

#### FocusFirst()

Focuses the first focusable subview if one exists.

##### Declaration

    public void FocusFirst()

#### FocusLast()

Focuses the last focusable subview if one exists.

##### Declaration

    public void FocusLast()

#### FocusNext()

Focuses the next view.

##### Declaration

    public bool FocusNext()

##### Returns

Type | Description
--- | ---
System.Boolean | `true`, if next was focused, `false` otherwise.

#### FocusPrev()

Focuses the previous view.

##### Declaration

    public bool FocusPrev()

##### Returns

Type | Description
--- | ---
System.Boolean | `true`, if previous was focused, `false` otherwise.

#### GetAutoSize()

Gets the size to fit all text if AutoSize is true.

##### Declaration

    public Size GetAutoSize()

##### Returns

Type | Description
--- | ---
Size | The Size

#### GetBoundsTextFormatterSize()

Gets the text formatter size from a Bounds size.

##### Declaration

    public Size GetBoundsTextFormatterSize()

##### Returns

Type | Description
--- | ---
Size | The text formatter size more the HotKeySpecifier length.

#### GetCurrentHeight(out Int32)

Calculate the height based on the Height settings.

##### Declaration

    public bool GetCurrentHeight(out int currentHeight)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | currentHeight | The real current height.

##### Returns

Type | Description
--- | ---
System.Boolean | `true` if the height can be directly assigned, `false` otherwise.

#### GetCurrentWidth(out Int32)

Gets the current width based on the Width settings.

##### Declaration

    public bool GetCurrentWidth(out int currentWidth)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | currentWidth | The real current width.

##### Returns

Type | Description
--- | ---
System.Boolean | `true` if the width can be directly assigned, `false` otherwise.

#### GetHotKeySpecifierLength(Boolean)

Get the width or height of the HotKeySpecifier length.

##### Declaration

    public int GetHotKeySpecifierLength(bool isWidth = true)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Boolean | isWidth | `true`if is the width (default)`false`if is the height.

##### Returns

Type | Description
--- | ---
System.Int32 | The length of the HotKeySpecifier.

#### GetKeyFromCommand(Command)

Gets the key used by a command.

##### Declaration

    public Key GetKeyFromCommand(Command command)

##### Parameters

Type | Name | Description
--- | --- | ---
Command | command | The command to search.

##### Returns

Type | Description
--- | ---
Key | The Key used by a Command

#### GetMinWidthHeight(out Size)

Verifies if the minimum width or height can be sets in the view.

##### Declaration

    public bool GetMinWidthHeight(out Size size)

##### Parameters

Type | Name | Description
--- | --- | ---
Size | size | The size.

##### Returns

Type | Description
--- | ---
System.Boolean | true if the size can be set, falseotherwise.

#### GetNormalColor()

Determines the current ColorScheme based on the Enabled value.

##### Declaration

    public Attribute GetNormalColor()

##### Returns

Type | Description
--- | ---
Attribute | Normal if Enabled is true or Disabled if Enabled is false

#### GetSupportedCommands()

Returns all commands that are supported by this View

##### Declaration

    public IEnumerable<Command> GetSupportedCommands()

##### Returns

Type | Description
--- | ---
System.Collections.Generic.IEnumerable<Command> |

#### GetTextFormatterBoundsSize()

Gets the bounds size from a Size.

##### Declaration

    public Size GetTextFormatterBoundsSize()

##### Returns

Type | Description
--- | ---
Size | The bounds size minus the HotKeySpecifier length.

#### GetTopSuperView()

Get the top superview of a given View.

##### Declaration

    public View GetTopSuperView()

##### Returns

Type | Description
--- | ---
View | The superview view.

#### InvokeKeybindings(KeyEvent)

Invokes any binding that is registered on this View and matches the `keyEvent`

##### Declaration

    protected Nullable<bool> InvokeKeybindings(KeyEvent keyEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | keyEvent | The key event passed.

##### Returns

Type | Description
--- | ---
System.Nullable<System.Boolean> |

#### LayoutSubviews()

Invoked when a view starts executing or when the dimensions of the view have changed, for example in response to the container view or terminal resizing.

##### Declaration

    public virtual void LayoutSubviews()

#### Move(Int32, Int32, Boolean)

This moves the cursor to the specified column and row in the view.

##### Declaration

    public void Move(int col, int row, bool clipped = true)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | col | Col.
System.Int32 | row | Row.
System.Boolean | clipped | Whether to clip the result of the ViewToScreen method, if set to `true`, the col, row values are clamped to the screen (terminal) dimensions (0..TerminalDim-1).

#### OnAdded(View)

Method invoked when a subview is being added to this view.

##### Declaration

    public virtual void OnAdded(View view)

##### Parameters

Type | Name | Description
--- | --- | ---
View | view | The subview being added.

#### OnCanFocusChanged()

Method invoked when the CanFocus property from a view is changed.

##### Declaration

    public override void OnCanFocusChanged()

##### Overrides

Responder.OnCanFocusChanged()

#### OnDrawContent(Rect)

Enables overrides to draw infinitely scrolled content and/or a background behind added controls.

##### Declaration

    public virtual void OnDrawContent(Rect viewport)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | viewport | The view-relative rectangle describing the currently visible viewport into the View

#### OnDrawContentComplete(Rect)

Enables overrides after completed drawing infinitely scrolled content and/or a background behind removed controls.

##### Declaration

    public virtual void OnDrawContentComplete(Rect viewport)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | viewport | The view-relative rectangle describing the currently visible viewport into the View

#### OnEnabledChanged()

Method invoked when the Enabled property from a view is changed.

##### Declaration

    public override void OnEnabledChanged()

##### Overrides

Responder.OnEnabledChanged()

#### OnEnter(View)

Method invoked when a view gets focus.

##### Declaration

    public override bool OnEnter(View view)

##### Parameters

Type | Name | Description
--- | --- | ---
View | view | The view that is losing focus.

##### Returns

Type | Description
--- | ---
System.Boolean | `true`, if the event was handled, `false` otherwise.

##### Overrides

Responder.OnEnter(View)

#### OnKeyDown(KeyEvent)

Method invoked when a key is pressed.

##### Declaration

    public override bool OnKeyDown(KeyEvent keyEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | keyEvent | Contains the details about the key that produced the event.

##### Returns

Type | Description
--- | ---
System.Boolean | true if the event was handled

##### Overrides

Responder.OnKeyDown(KeyEvent)

#### OnKeyUp(KeyEvent)

Method invoked when a key is released.

##### Declaration

    public override bool OnKeyUp(KeyEvent keyEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | keyEvent | Contains the details about the key that produced the event.

##### Returns

Type | Description
--- | ---
System.Boolean | true if the event was handled

##### Overrides

Responder.OnKeyUp(KeyEvent)

#### OnLeave(View)

Method invoked when a view loses focus.

##### Declaration

    public override bool OnLeave(View view)

##### Parameters

Type | Name | Description
--- | --- | ---
View | view | The view that is getting focus.

##### Returns

Type | Description
--- | ---
System.Boolean | `true`, if the event was handled, `false` otherwise.

##### Overrides

Responder.OnLeave(View)

#### OnMouseClick(View.MouseEventArgs)

Invokes the MouseClick event.

##### Declaration

    protected bool OnMouseClick(View.MouseEventArgs args)

##### Parameters

Type | Name | Description
--- | --- | ---
View.MouseEventArgs | args |

##### Returns

Type | Description
--- | ---
System.Boolean |

#### OnMouseEnter(MouseEvent)

Method invoked when a mouse event is generated for the first time.

##### Declaration

    public override bool OnMouseEnter(MouseEvent mouseEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
MouseEvent | mouseEvent |

##### Returns

Type | Description
--- | ---
System.Boolean | `true`, if the event was handled, `false` otherwise.

##### Overrides

Responder.OnMouseEnter(MouseEvent)

#### OnMouseEvent(MouseEvent)

Method invoked when a mouse event is generated

##### Declaration

    public virtual bool OnMouseEvent(MouseEvent mouseEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
MouseEvent | mouseEvent |

##### Returns

Type | Description
--- | ---
System.Boolean | `true`, if the event was handled, `false` otherwise.

#### OnMouseLeave(MouseEvent)

Method invoked when a mouse event is generated for the last time.

##### Declaration

    public override bool OnMouseLeave(MouseEvent mouseEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
MouseEvent | mouseEvent |

##### Returns

Type | Description
--- | ---
System.Boolean | `true`, if the event was handled, `false` otherwise.

##### Overrides

Responder.OnMouseLeave(MouseEvent)

#### OnRemoved(View)

Method invoked when a subview is being removed from this view.

##### Declaration

    public virtual void OnRemoved(View view)

##### Parameters

Type | Name | Description
--- | --- | ---
View | view | The subview being removed.

#### OnVisibleChanged()

Method invoked when the Visible property from a view is changed.

##### Declaration

    public override void OnVisibleChanged()

##### Overrides

Responder.OnVisibleChanged()

#### PositionCursor()

Positions the cursor in the right position based on the currently focused view in the chain.

##### Declaration

    public virtual void PositionCursor()

#### ProcessColdKey(KeyEvent)

This method can be overwritten by views that want to provide accelerator functionality (Alt-key for example), but without interefering with normal ProcessKey behavior.

##### Declaration

    public override bool ProcessColdKey(KeyEvent keyEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | keyEvent | Contains the details about the key that produced the event.

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

Responder.ProcessColdKey(KeyEvent)

#### ProcessHotKey(KeyEvent)

This method can be overwritten by view that want to provide accelerator functionality (Alt-key for example).

##### Declaration

    public override bool ProcessHotKey(KeyEvent keyEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | keyEvent |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

Responder.ProcessHotKey(KeyEvent)

#### ProcessKey(KeyEvent)

If the view is focused, gives the view a chance to process the keystroke.

##### Declaration

    public override bool ProcessKey(KeyEvent keyEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | keyEvent | Contains the details about the key that produced the event.

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

Responder.ProcessKey(KeyEvent)

#### ProcessResizeView()

Can be overridden if the view resize behavior is different than the default.

##### Declaration

    protected virtual void ProcessResizeView()

#### Redraw(Rect)

Redraws this view and its subviews; only redraws the views that have been flagged for a re-display.

##### Declaration

    public virtual void Redraw(Rect bounds)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | bounds | The bounds (view-relative region) to redraw.

#### Remove(View)

Removes a subview added via Add(View) or Add(View[]) from this View.

##### Declaration

    public virtual void Remove(View view)

##### Parameters

Type | Name | Description
--- | --- | ---
View | view |

#### RemoveAll()

Removes all subviews (children) added via Add(View) or Add(View[]) from this View.

##### Declaration

    public virtual void RemoveAll()

#### ReplaceKeyBinding(Key, Key)

Replaces a key combination already bound to Command.

##### Declaration

    protected void ReplaceKeyBinding(Key fromKey, Key toKey)

##### Parameters

Type | Name | Description
--- | --- | ---
Key | fromKey | The key to be replaced.
Key | toKey | The new key to be used.

#### ScreenToView(Int32, Int32)

Converts a point from screen-relative coordinates to view-relative coordinates.

##### Declaration

    public Point ScreenToView(int x, int y)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | x | X screen-coordinate point.
System.Int32 | y | Y screen-coordinate point.

##### Returns

Type | Description
--- | ---
Point | The mapped point.

#### SendSubviewBackwards(View)

Moves the subview backwards in the hierarchy, only one step

##### Declaration

    public void SendSubviewBackwards(View subview)

##### Parameters

Type | Name | Description
--- | --- | ---
View | subview | The subview to send backwards

#### SendSubviewToBack(View)

Sends the specified subview to the front so it is the first view drawn

##### Declaration

    public void SendSubviewToBack(View subview)

##### Parameters

Type | Name | Description
--- | --- | ---
View | subview | The subview to send to the front

#### SetChildNeedsDisplay()

Indicates that any child views (in the Subviews list) need to be repainted.

##### Declaration

    public void SetChildNeedsDisplay()

#### SetClip(Rect)

Sets the clip region to the specified view-relative region.

##### Declaration

    public Rect SetClip(Rect region)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | region | View-relative clip region.

##### Returns

Type | Description
--- | ---
Rect | The previous screen-relative clip region.

#### SetFocus()

Causes the specified view and the entire parent hierarchy to have the focused order updated.

##### Declaration

    public void SetFocus()

#### SetHeight(Int32, out Int32)

Calculate the height based on the Height settings.

##### Declaration

    public bool SetHeight(int desiredHeight, out int resultHeight)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | desiredHeight | The desired height.
System.Int32 | resultHeight | The real result height.

##### Returns

Type | Description
--- | ---
System.Boolean | `true` if the height can be directly assigned, `false` otherwise.

#### SetMinWidthHeight()

Sets the minimum width or height if the view can be resized.

##### Declaration

    public bool SetMinWidthHeight()

##### Returns

Type | Description
--- | ---
System.Boolean | true if the size can be set, falseotherwise.

#### SetNeedsDisplay()

Sets a flag indicating this view needs to be redisplayed because its state has changed.

##### Declaration

    public void SetNeedsDisplay()

#### SetNeedsDisplay(Rect)

Flags the view-relative region on this View as needing to be repainted.

##### Declaration

    public void SetNeedsDisplay(Rect region)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | region | The view-relative region that must be flagged for repaint.

#### SetWidth(Int32, out Int32)

Calculate the width based on the Width settings.

##### Declaration

    public bool SetWidth(int desiredWidth, out int resultWidth)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | desiredWidth | The desired width.
System.Int32 | resultWidth | The real result width.

##### Returns

Type | Description
--- | ---
System.Boolean | `true` if the width can be directly assigned, `false` otherwise.

#### ToString()

Pretty prints the View

##### Declaration

    public override string ToString()

##### Returns

Type | Description
--- | ---
System.String |

#### UpdateTextFormatterText()

Can be overridden if the Text has different format than the default.

##### Declaration

    protected virtual void UpdateTextFormatterText()

### Events

#### Added

Event fired when a subview is being added to this view.

##### Declaration

    public event Action<View> Added

##### Event Type

Type | Description
--- | ---
System.Action<View> |

#### CanFocusChanged

Event fired when the CanFocus value is being changed.

##### Declaration

    public event Action CanFocusChanged

##### Event Type

Type | Description
--- | ---
System.Action |

#### DrawContent

Event invoked when the content area of the View is to be drawn.

##### Declaration

    public event Action<Rect> DrawContent

##### Event Type

Type | Description
--- | ---
System.Action<Rect> |

#### DrawContentComplete

Event invoked when the content area of the View is completed drawing.

##### Declaration

    public event Action<Rect> DrawContentComplete

##### Event Type

Type | Description
--- | ---
System.Action<Rect> |

#### EnabledChanged

Event fired when the Enabled value is being changed.

##### Declaration

    public event Action EnabledChanged

##### Event Type

Type | Description
--- | ---
System.Action |

#### Enter

Event fired when the view gets focus.

##### Declaration

    public event Action<View.FocusEventArgs> Enter

##### Event Type

Type | Description
--- | ---
System.Action<View.FocusEventArgs> |

#### HotKeyChanged

Event invoked when the HotKey is changed.

##### Declaration

    public event Action<Key> HotKeyChanged

##### Event Type

Type | Description
--- | ---
System.Action<Key> |

#### Initialized

Event called only once when the View is being initialized for the first time. Allows configurations and assignments to be performed before the View being shown. This derived from System.ComponentModel.ISupportInitializeNotification to allow notify all the views that are being initialized.

##### Declaration

    public event EventHandler Initialized

##### Event Type

Type | Description
--- | ---
System.EventHandler |

#### KeyDown

Invoked when a key is pressed

##### Declaration

    public event Action<View.KeyEventEventArgs> KeyDown

##### Event Type

Type | Description
--- | ---
System.Action<View.KeyEventEventArgs> |

#### KeyPress

Invoked when a character key is pressed and occurs after the key up event.

##### Declaration

    public event Action<View.KeyEventEventArgs> KeyPress

##### Event Type

Type | Description
--- | ---
System.Action<View.KeyEventEventArgs> |

#### KeyUp

Invoked when a key is released

##### Declaration

    public event Action<View.KeyEventEventArgs> KeyUp

##### Event Type

Type | Description
--- | ---
System.Action<View.KeyEventEventArgs> |

#### LayoutComplete

Fired after the Views's LayoutSubviews() method has completed.

##### Declaration

    public event Action<View.LayoutEventArgs> LayoutComplete

##### Event Type

Type | Description
--- | ---
System.Action<View.LayoutEventArgs> |

#### LayoutStarted

Fired after the Views's LayoutSubviews() method has completed.

##### Declaration

    public event Action<View.LayoutEventArgs> LayoutStarted

##### Event Type

Type | Description
--- | ---
System.Action<View.LayoutEventArgs> |

#### Leave

Event fired when the view looses focus.

##### Declaration

    public event Action<View.FocusEventArgs> Leave

##### Event Type

Type | Description
--- | ---
System.Action<View.FocusEventArgs> |

#### MouseClick

Event fired when a mouse event is generated.

##### Declaration

    public event Action<View.MouseEventArgs> MouseClick

##### Event Type

Type | Description
--- | ---
System.Action<View.MouseEventArgs> |

#### MouseEnter

Event fired when the view receives the mouse event for the first time.

##### Declaration

    public event Action<View.MouseEventArgs> MouseEnter

##### Event Type

Type | Description
--- | ---
System.Action<View.MouseEventArgs> |

#### MouseLeave

Event fired when the view receives a mouse event for the last time.

##### Declaration

    public event Action<View.MouseEventArgs> MouseLeave

##### Event Type

Type | Description
--- | ---
System.Action<View.MouseEventArgs> |

#### Removed

Event fired when a subview is being removed from this view.

##### Declaration

    public event Action<View> Removed

##### Event Type

Type | Description
--- | ---
System.Action<View> |

#### VisibleChanged

Event fired when the Visible value is being changed.

##### Declaration

    public event Action VisibleChanged

##### Event Type

Type | Description
--- | ---
System.Action |

### Implements

System.IDisposable
System.ComponentModel.ISupportInitializeNotification
System.ComponentModel.ISupportInitialize